<?php
class Ameex_Insurance_Block_Adminhtml_Serialcodegen_GridContainer_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
   public function __construct()
   {
       parent::__construct();
       $this->setId('serialcodegen');
       $this->setDefaultSort('id');
       $this->setDefaultDir('ASC');
       $this->setUseAjax(true);
       $this->setSaveParametersInSession(true);
   }
   
   protected function _prepareCollection()
   {
      $collection = Mage::getModel('ameex_insurance/serialcode')->getCollection();
      $this->setCollection($collection);
      return parent::_prepareCollection();
   }
    
   protected function _prepareColumns()
   {
		$this->addColumn('id', array(
                    'header' => Mage::helper('ameex_insurance')->__('Serialcode Id'),
                    'index' => 'id',
               ));
		
		$this->addColumn('sku', array(
                    'header' => Mage::helper('ameex_insurance')->__('Product Name'),
                    'index' => 'sku',
                    'type' => 'options',
                    'options' => Mage::getModel('ameex_insurance/options')->getProdsku(),                    
               ));

		$this->addColumn('serialcode_type', array(
                    'header' => Mage::helper('ameex_insurance')->__('Serial Code Type'),
                    'index' => 'serialcode_type',
               ));

             $this->addColumn('retailer_id', array(
                    'header' => Mage::helper('ameex_insurance')->__('Select Retailer'),
                    'index' => 'retailer_id',
                    'type' => 'options',
                    'options' => Mage::getModel('ameex_insurance/options')->getRetailers(),                 
               ));
       
		$this->addColumn('activation_code', array(
                    'header' => Mage::helper('ameex_insurance')->__('Serial Code'),
                    'index' => 'activation_code',
               ));
     /*        $this->addColumn('status', array(
                    'header' => Mage::helper('ameex_insurance')->__('Status'),
                    'index' => 'status',
                    'type' => 'options',
                    'options' => Mage::getModel('ameex_insurance/options')->getEnableDisable(), 
               ));                */
		
		$this->addExportType('*/*/exportCsv', Mage::helper('ameex_insurance')->__('CSV'));
       
        return parent::_prepareColumns();
    }

	public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
    
  // public function getRowUrl($row)
  //  {
  //     return $this->getUrl('*/*/edit', array('id' => $row->getId()));
//   } 
    
    protected function _prepareMassaction()
	{
		$this->setMassactionIdField('id');
		$this->getMassactionBlock()->setFormFieldName('id');
		$this->getMassactionBlock()->addItem('delete', array(
			'label'		=> Mage::helper('ameex_insurance')->__('Delete'),
			'url'  		=> $this->getUrl('*/serialcodegen/massDelete', array('' => '')),
		));            
		$this->getMassactionBlock()->addItem('edit', array(
			'label'		=> Mage::helper('ameex_insurance')->__('Edit'),
			'url'  		=> $this->getUrl('*/serialcodegen/massedit', array('' => '')),
		));                  
		 
		return $this;
	}
}
