<?php

class Limex_B2b_Block_Adminhtml_B2b_Edit extends Mage_Adminhtml_Block_Widget_Form_Container
{
    public function __construct()
    {
        parent::__construct();
                 
        $this->_objectId = 'id';
        $this->_blockGroup = 'b2b';
        $this->_controller = 'adminhtml_b2b';
        
        $this->_updateButton('save', 'label', Mage::helper('b2b')->__('Save Item'));
        $this->_updateButton('delete', 'label', Mage::helper('b2b')->__('Delete Item'));
		
        $this->_addButton('saveandcontinue', array(
            'label'     => Mage::helper('adminhtml')->__('Save And Continue Edit'),
            'onclick'   => 'saveAndContinueEdit()',
            'class'     => 'save',
        ), -100);

        $this->_formScripts[] = "
            function toggleEditor() {
                if (tinyMCE.getInstanceById('b2b_content') == null) {
                    tinyMCE.execCommand('mceAddControl', false, 'b2b_content');
                } else {
                    tinyMCE.execCommand('mceRemoveControl', false, 'b2b_content');
                }
            }

            function saveAndContinueEdit(){
                editForm.submit($('edit_form').action+'back/edit/');
            }
        ";
    }

    public function getHeaderText()
    {
        if( Mage::registry('b2b_data') && Mage::registry('b2b_data')->getId() ) {
            return Mage::helper('b2b')->__("Edit Item '%s'", $this->htmlEscape(Mage::registry('b2b_data')->getTitle()));
        } else {
            return Mage::helper('b2b')->__('Add Item');
        }
    }
}