<?php

class Magegiant_Affiliatereport_IndexController extends Mage_Adminhtml_Controller_Action
{
    protected function _initAction()
    {
        $this->loadLayout()
            ->_setActiveMenu('affiliate/statistic/chart')
            ->_addBreadcrumb(Mage::helper('adminhtml')->__('Affiliate'), Mage::helper('adminhtml')->__('Statistic'));

        return $this;
    }

    public function indexAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $this->_title($this->__('Affiliate'))->_title($this->__('Statistic'));
        $this->_initAction()
            ->renderLayout();
    }

    public function tunnelAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $httpClient = new Varien_Http_Client();
        $gaData     = $this->getRequest()->getParam('ga');
        $gaHash     = $this->getRequest()->getParam('h');
        if ($gaData && $gaHash) {
            $newHash = Mage::helper('adminhtml/dashboard_data')->getChartDataHash($gaData);
            if ($newHash == $gaHash) {
                if ($params = unserialize(base64_decode(urldecode($gaData)))) {
                    $response = $httpClient->setUri(Mage_Adminhtml_Block_Dashboard_Graph::API_URL)
                        ->setParameterGet($params)
                        ->setConfig(array('timeout' => 5))
                        ->request('GET');

                    $headers = $response->getHeaders();

                    $this->getResponse()
                        ->setHeader('Content-type', $headers['Content-type'])
                        ->setBody($response->getBody());
                }
            }
        }
    }

    public function ajaxBlockAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $output   = '';
        $blockTab = $this->getRequest()->getParam('block');
        if (in_array($blockTab, array(
            'diagrams_sales',
            'diagrams_transactions',
            'diagrams_commissions',
            'diagrams_totals',
            'diagrams_traffics',
            'diagrams_impressions',
        ))
        ) {
            $output = $this->getLayout()->createBlock("affiliatereport/$blockTab")->toHtml();
        }
        $this->getResponse()->setBody($output);
    }

    public function accountsAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $this->getResponse()->setBody($this->getLayout()->createBlock('affiliatereport/grids_accounts')->toHtml());
    }

    public function bestsellerAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $this->getResponse()->setBody($this->getLayout()->createBlock('affiliatereport/grids_bestseller')->toHtml());
    }

    public function affiliatesAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $this->getResponse()->setBody($this->getLayout()->createBlock('affiliatereport/grids_affiliates')->toHtml());
    }

    public function referersAction()
    {
        if (!Mage::helper('magegiantcore')->checkLicenseKeyAdminController($this)) {
            return;
        }
        $this->getResponse()->setBody($this->getLayout()->createBlock('affiliatereport/grids_referers')->toHtml());
    }
}