// For support email: support@rocketship.it

module.exports = {
    api_key: '',

    request: function(carrier, action, params) {
        var req = {
            carrier: carrier,
            action: action,
            params: params
        }
        var data = '';
        var child_process = require('child_process');
        var general_error = { "meta": { "code": 500, "error_message": "Unable to communicate with RocketShipIt" } };

        var proc = child_process.spawn('./RocketShipIt', [], { cwd: __dirname });
        proc.stdout.setEncoding('utf8');
        proc.stdout.on('data', function(chunk) {
            data += chunk;
        });
        proc.stdout.on('end', function() {
            return callback(JSON.parse(data.toString()));
        })
        proc.stderr.on('data', function(data) {});
        proc.on('error', function(data) {
            reject(general_error);
        });

        proc.stdin.write(JSON.stringify(req));
        proc.stdin.end();
    },
    httpRequest: function(req, callback) {
        var http = require('https')

        var body = JSON.stringify(req);

        var request = new http.request({
            hostname: "api.rocketship.it",
            port: 443,
            path: "/v1/",
            method: "POST",
            json: true,
            headers: {
                "x-api-key": this.api_key,
                "Content-Type": "application/json",
                "Content-Length": Buffer.byteLength(body)
            }
        });
        request.end(body);

        request.on('response', function(response) {
            response.setEncoding('utf8');
            response.on('data', function(chunk) {
                return callback(JSON.parse(chunk))
            });
        });
    }
};
